<?php
/*******************************************************************************
 * Plugin En avant pour Thélia.
 * -----------------------------------------------------------------------------
 * Date de création : aout 2010
 * Version : 1.0
 * -----------------------------------------------------------------------------
 * Auteur : Xavier TEZZA
 *   Mail : contact@xdreamweb.com
 *   Site web : http://www.xdreamweb.com
 ******************************************************************************/
?>
<?php
  include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	
	
	class Enavant extends PluginsClassiques{

		function Enavant(){
			$this->PluginsClassiques();	
		}
    
		function charger($id, $langue="fr"){
		}
		
		// fonction appelée à l'installation du plugin : on ne fait rien de particulier
		function init(){
		$sql ="ALTER TABLE `produit` ADD `enavant` SMALLINT( 6 ) NOT NULL DEFAULT '0'";
		$resul = mysql_query($sql);
		}
		// fonction appelée à la désinstallation du plugin : on n'efface surtout pas les données de la base !
		function destroy(){
		}
		
		function boucle($texte, $args){
			
			global $page, $totbloc, $ref, $pagesess;
			
			// récupération des arguments
			$rubrique = lireTag($args, "rubrique", "int_list");
			$deb = lireTag($args, "deb", "int");
			$num = lireTag($args, "num", "int");
			$passage = lireTag($args, "passage", "int");
			$ligne = lireTag($args, "ligne", "int");
			$bloc = lireTag($args, "bloc", "int+-");
			$nouveaute = lireTag($args, "nouveaute", "int");
			$promo = lireTag($args, "promo", "int");
			$reappro = lireTag($args, "reappro", "int");
			$refp = lireTag($args, "ref", "string");
			$id = lireTag($args, "id", "int_list");
			$garantie = lireTag($args, "garantie", "int");
			$motcle = lireTag($args, "motcle", "string+\s\'");
			$classement = lireTag($args, "classement", "string");
			$aleatoire = lireTag($args, "aleatoire", "int");
			$prixmin = lireTag($args, "prixmin", "float");
			$prixmax = lireTag($args, "prixmax", "float");
			$caracteristique = lireTag($args, "caracteristique", "int+-");
			$caracdisp = lireTag($args, "caracdisp", "int+-");
			$caracval = lireTag($args, "caracval", "string+\s\'\/");
			$typech = lireTag($args, "typech", "string");
			$declinaison = lireTag($args, "declinaison", "int+-");			
			$declidisp = lireTag($args, "declidisp", "int+-");
			$declistockmini = lireTag($args, "declistockmini", "int");
			$stockmini = lireTag($args, "stockmini", "int");
			$courant = lireTag($args, "courant", "int");
			$profondeur = lireTag($args, "profondeur", "int");		
			$exclusion = lireTag($args, "exclusion", "int_list");
			$exclurub = lireTag($args, "exclurub", "int_list");			
			$poids = lireTag($args, "poids", "float");
			$stockvide = lireTag($args, "stockvide", "int");
			$forcepage = lireTag($args, "forcepage", "int");
						
			if($bloc) $totbloc=$bloc;
			if($deb) $debsave = $deb;
			else $debsave = 0;
			
			if(!$deb) $deb=0;
			
			if($page) $_SESSION['navig']->page = $page;
			if($pagesess == 1) $page =  $_SESSION['navig']->page;
			
			if(!$page ||  $page==1 ) $page=0; 
			
			if(!$totbloc) $totbloc=1;
			if($page) $deb = ($page-1)*$totbloc*$num+$deb; 

			if($forcepage != "") {
				if($forcepage == 1){
					$forcepage = 0;
					$deb = 0;
				}	
				
				if($forcepage) $deb = ($forcepage-1)*$totbloc*$num+$deb;
			}
				
			// initialisation de variables
			$search = " and enavant=1";
			$order = "";
			$comptbloc=0;
			$limit="";
			$pourcentage="";
			$res="";
			$virg="";
			
			// preparation de la requete
			
			if($courant == "1") $search .= " and ref=\"$ref\"";
			else if($courant == "0") $search .= " and ref<>\"$ref\"";
			
			if($exclusion!="") $search .= " and id not in($exclusion)";
			if($exclurub!="") $search .= " and rubrique not in($exclurub)";
			
			if($rubrique!=""){
				$srub = "";
				
				if($profondeur == "") $profondeur=0;
				$tabrub = explode(",", $rubrique);
				for($compt = 0; $compt<count($tabrub); $compt++){
					$rec = arbreBoucle($tabrub[$compt], $profondeur);
					if(substr($rec, strlen($rec)-1) == ",") $rec = substr($rec, 0, strlen($rec)-1);
					if($rec) $virg=",";
					$srub .= $tabrub[$compt] . $virg . $rec . $virg;
				}
				if(substr($srub, strlen($srub)-1) == ",")
					$srub = substr($srub, 0, strlen($srub)-1);
				 $search .= " and rubrique in($srub)";
			}
			
			if($ligne == "") $ligne="1";

			if($ligne != "-1") $search .= " and ligne=\"$ligne\"";
			if($id!="") $search .= " and id in ($id)";	 
			if($nouveaute!="") $search .= " and nouveaute=\"$nouveaute\"";
			if($promo!="") $search .= " and promo=\"$promo\"";
			if($reappro!="") $search .= " and reappro=\"$reappro\"";
			if($garantie!="") $search .= " and garantie=\"$garantie\"";
			if($prixmin!="") $search .= " and ((prix2>=\"$prixmin\" and promo=\"1\") or (prix>=\"$prixmin\" and promo=\"0\"))";
			if($prixmax!="") $search .= " and ((prix2<=\"$prixmax\" and promo=\"1\") or (prix<=\"$prixmax\" and promo=\"0\"))";
			if($poids!="") $search .= " and poids<=\"$poids\"";
			if($stockmini!="" && $declistockmini == "") $search .= " and stock>=\"$stockmini\"";

			if (""!=$stockvide) {
				if (0 < $stockvide) { $search .= " and stock<=\"0\""; }
				elseif (0 >= $stockvide) { $search .= " and stock>\"0\""; }
			}
									
			if($refp!="") $search .= " and ref=\"$refp\"";

			if($bloc == "-1") $bloc = "999999999";
			if($bloc!="" && $num!="") $limit .= " limit $deb,$bloc";
			else if($num!="") $limit .= " limit $deb,$num";
			
			if($aleatoire) $order = "order by "  . " RAND()";
			else if($classement == "prixmin") $order = "order by "  . " prix";
			else if($classement == "prixmax") $order = "order by "  . " prix desc";
			else if($classement == "rubrique") $order = "order by "  . " rubrique";
			else if($classement == "manuel") $order = "order by classement";
			else if($classement == "inverse") $order = "order by classement desc";
			else if($classement == "date") $order = "order by datemodif desc";
			else if($classement == "titre") $order = "order by titre";
            else if($classement == "titreinverse") $order = "order by titre desc";
            else if($classement == "ref") $order = "order by ref";
            else if($classement == "promo") $order = "order by promo desc";
			else $order = "order by classement";
			
		
			
			$produit = new Produit();
			// Demande de caracteristiques 
			if($caracdisp != ""){
			
				if(substr($caracteristique,strlen($caracteristique)-1,strlen($caracteristique)) != "-") $caracteristique .= "-";
				if(substr($caracdisp,strlen($caracdisp)-1,strlen($caracdisp)) != "-") $caracdisp .= "-";
			
			$lcaracteristique = explode("-", $caracteristique);
			$lcaracdisp = explode("-", $caracdisp);
			
			$i = 0;

			$tcaracval = new Caracval();

			while($i<count($lcaracteristique)-1){
				$caracteristique = $lcaracteristique[$i];
				$caracdisp = $lcaracdisp[$i];
				if($caracdisp == "*")
					$query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp<>''";
				else if($caracdisp == "-")	$query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp=''";
				else $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and caracdisp='$caracdisp'";

				$liste="";
				$resul = CacheBase::getCache()->mysql_query($query, $caracteristique->link);
				if($resul=="" || count($resul)==0) return;

				foreach($resul as $row)
					$liste .= "'$row->produit', ";
			
				$liste = substr($liste, 0, strlen($liste) - 2);
				
				$i++;
				
				if($liste!="") $search .= " and $produit->table.id in($liste)";	
				else return "";
			}

			

		}	

			if($caracval != ""){
			
			$i = 0;
			$liste="";

			$tcaracval = new Caracval();

				if($caracval == "*") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur<>''";
				else if($caracval == "-") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur=''";
				else if($typech == "like") $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur like '$caracval'";
				else $query = "select * from $tcaracval->table where caracteristique='$caracteristique' and valeur ='$caracval'";

				$liste="";
				$resul = CacheBase::getCache()->mysql_query($query, $caracval->link);
				if($resul == "" || count($resul) == 0) return "";
				foreach($resul as $row) 
					$liste .= "'$row->produit', ";
				$liste = substr($liste, 0, strlen($liste) - 2);
				
				$i++;
			
			
			if($liste!="") $search .= " and $produit->table.id in($liste)";	
			else return "";
		}	


			// Demande de declinaisons 
			if($declidisp != ""){

			if(! strstr($declinaison, "-")) $declinaison .= "-";
			if(! strstr($declidisp, "-")) $declidisp .= "-";
			if(! strstr($ldeclistockmini, "-")) $ldeclistockmini .= "-";
				
			$ldeclinaison = explode("-", $declinaison);
			$ldeclidisp = explode("-", $declidisp);
			$ldeclistockmini = explode("-", $declistockmini);
			
			$i = 0;
			$liste="";
			$exdecprod = new Exdecprod();
			$stock = new Stock();

			while($i<count($ldeclinaison)-1){

				$declinaison = $ldeclinaison[$i];
				$declidisp = $ldeclidisp[$i];
				$declistockmini = $ldeclistockmini[$i];
				
		 		$query = "select * from $exdecprod->table where declidisp='$declidisp'";
				$resul = CacheBase::getCache()->mysql_query($query,null);
				if(count($resul) > 0)
					foreach($resul as $row) 
						$liste .= "'$row->produit', ";
	
				if($liste!="") {
						$liste = substr($liste, 0, strlen($liste) - 2);
						$search .= " and $produit->table.id not in($liste)";
				}	
		
				$liste="";
				
				if($declistockmini != ""){
					$query = "select * from $stock->table where declidisp='$declidisp' and valeur>='$declistockmini'";
					$resul = CacheBase::getCache()->mysql_query($query,null);

					if(count($resul) > 0)
						foreach($resul as $row)
							$liste .= "'$row->produit', ";

					if($liste!="") {
								$liste = substr($liste, 0, strlen($liste) - 2);
								$search .= " and $produit->table.id in($liste)";
					}
					else return "";
				}	
			
				$i++;

			}
		
		}
				
			$produit = new Produit();
			$produitdesc = new Produitdesc();
			
		
			if($motcle){
				$motcle = strip_tags($motcle);
				$liste="";
				
  				$query = "select * from $produitdesc->table  LEFT JOIN $produit->table ON $produit->table.id=$produitdesc->table.produit WHERE $produit->table.ref='$motcle' or titre like '% $motcle%' or titre like '%$motcle %' OR titre='$motcle' OR chapo like '% $motcle%' OR chapo like '%$motcle %' OR description like '% $motcle%' OR description like '%$motcle %' OR postscriptum like '% $motcle%' OR postscriptum like '%$motcle %'";
			
				$resul = CacheBase::getCache()->mysql_query($query, $produitdesc->link);
				if($resul=="" || count($resul)==0) return "";

				foreach($resul as $row) {
					$liste .= "'$row->produit', ";
				}
			
				$liste = substr($liste, 0, strlen($liste) - 2);
				$search .= "and $produit->table.id in ($liste)";
			
			}
		
		if($classement != "titre" && $classement != "titreinverse"){
			$query = "select * from $produit->table where 1 $search $order $limit";
			$classement = "produit";
	    }
	
		else {
			$query = "select * from $produit->table, $produitdesc->table where $produit->table.id=$produitdesc->table.produit and $produitdesc->table.lang=\"" . $_SESSION['navig']->lang . "\" $search $order $limit";
			$classement = "produitdesc";
		}
            
		$resul = CacheBase::getCache()->mysql_query($query, $produit->link);
		if($resul=="" || count($resul)==0) return "";

		$saveReq = "select * from $produit->table where 1 $search";

		// substitutions
		if($type) return $query;
		
		$saveReq = str_replace("*", "count(id) as totcount", $saveReq);
		$saveRes = CacheBase::getCache()->mysql_query($saveReq,$produit->link);
		$countRes = $saveRes[0]->totcount. " ";
	
		$compt = 0;
		
		foreach($resul as $row) {
					
			$compt++;
			
			if($passage != "" && $comptbloc>$passage-1)
			      break;
			
			if($num>0) 
				if($comptbloc>=ceil($countRes/$num) && $bloc!="") continue;

			if($comptbloc == 0) $debcourant=0;
			else $debcourant = $num * ($comptbloc);
			$comptbloc++;
						
			if($classement == "produit")
				$prodid = $row->id;
			else 
				$prodid = $row->produit;
				
			$rubriquedesc = new Rubriquedesc();
			$rubriquedesc->charger($row->rubrique, $_SESSION['navig']->lang);
		
			$produitdesc->charger($prodid, $_SESSION['navig']->lang);
				
			$temp = $texte;
			
			if( $row->promo == "1" ) $temp = preg_replace("/\#PROMO\[([^]]*)\]\[([^]]*)\]/", "\\1", $temp);
	 		else $temp = preg_replace("/\#PROMO\[([^]]*)\]\[([^]]*)\]/", "\\2", $temp);
	
			if( $row->nouveaute == "1" ) $temp = preg_replace("/\#NOUVEAU\[([^]]*)\]\[([^]]*)\]/", "\\1", $temp);
			else $temp = preg_replace("/\#NOUVEAU\[([^]]*)\]\[([^]]*)\]/", "\\2", $temp);
	 		
			if( $row->promo == "1" && $row->prix) $pourcentage =  ceil((100 * ($row->prix - $row->prix2)/$row->prix));

			$prixorig = $row->prix;
			$prix2orig = $row->prix2;
			
			$prix = $row->prix - ($row->prix * $_SESSION['navig']->client->pourcentage / 100);
			$prix2 = $row->prix2 - ($row->prix2 * $_SESSION['navig']->client->pourcentage / 100);
			
			$ecotaxe = $row->ecotaxe;
			
			$pays = new Pays();
			$pays->charger($_SESSION['navig']->client->pays);
			
			$zone = new Zone();
			$zone->charger($pays->zone);
			
			$prixht = $prix/(1+$row->tva/100);
			$prix2ht = $prix2/(1+$row->tva/100);
			$prixoright = $prixorig/(1+$row->tva/100);
			$prix2oright = $prix2orig/(1+$row->tva/100);			
			
			$ecotaxeht = $row->ecotaxe/(1+$row->tva/100);
				
			
			$prix = round($prix, 2);
			$prix2 = round($prix2, 2);
			$prixht = round($prixht, 2);
			$prix2ht = round($prix2ht, 2);
			$prixorig = round($prixorig, 2);
			$prix2orig = round($prix2orig, 2);
			$prixoright = round($prixoright, 2);
			$prix2oright = round($prix2oright, 2);
								
			$prix = number_format($prix, 2, ".", ""); 
			$prix2 = number_format($prix2, 2, ".", ""); 
			$prixht = number_format($prixht, 2, ".", ""); 
			$prix2ht = number_format($prix2ht, 2, ".", ""); 
			$prixorig = number_format($prixorig, 2, ".", ""); 
			$prix2orig = number_format($prix2orig, 2, ".", ""); 
			$prixoright = number_format($prixoright, 2, ".", ""); 
			$prix2oright = number_format($prix2oright, 2, ".", "");
			
			if($deb != "" && !$page) $debcourant+=$deb-1;
			
			$temp = str_replace("#REF", "$row->ref", $temp);
			$temp = str_replace("#COMPT", "$compt", $temp);
			$temp = str_replace("#DATE", substr($row->datemodif, 0, 10), $temp);
			$temp = str_replace("#HEURE", substr($row->datemodif, 11), $temp);
			$temp = str_replace("#DEBCOURANT", "$debcourant", $temp);
			$temp = str_replace("#ID", "$prodid", $temp);	
			$temp = str_replace("#PRIX2ORIGHT", "$prix2oright", $temp);	
			$temp = str_replace("#PRIX2ORIG", "$prix2orig", $temp);	
			$temp = str_replace("#PRIXORIGHT", "$prixoright", $temp);				
			$temp = str_replace("#PRIXORIG", "$prixorig", $temp);
			$temp = str_replace("#PRIX2HT", "$prix2ht", $temp);	
			$temp = str_replace("#PRIX2", "$prix2", $temp);	
			$temp = str_replace("#PRIXHT", "$prixht", $temp);				
			$temp = str_replace("#PRIX", "$prix", $temp);
			$temp = str_replace("#PROMO", "$row->promo", $temp);	
			$temp = str_replace("#TVA", "$row->tva", $temp);	
			$temp = str_replace("#ECOTAXEHT", "$ecotaxeht", $temp);	
			$temp = str_replace("#ECOTAXE", "$row->ecotaxe", $temp);	
			$temp = str_replace("#STOCK", "$row->stock", $temp);	
			$temp = str_replace("#POURCENTAGE", "$pourcentage", $temp);	
			$temp = str_replace("#RUBRIQUE", "$row->rubrique", $temp);			
			$temp = str_replace("#PERSO", "$row->perso", $temp);			
			$temp = str_replace("#POIDS", "$row->poids", $temp);			
			$temp = str_replace("#TITRE", "$produitdesc->titre", $temp);
			$temp = str_replace("#STRIPTITRE", strip_tags($produitdesc->titre), $temp);	
			$temp = str_replace("#CHAPO", "$produitdesc->chapo", $temp);	
			$temp = str_replace("#STRIPCHAPO", strip_tags($produitdesc->chapo), $temp);	
			$temp = str_replace("#DESCRIPTION", html_entity_decode(str_replace("../","",$produitdesc->description)), $temp);
			$temp = str_replace("#POSTSCRIPTUM", "$produitdesc->postscriptum", $temp);	
			$temp = str_replace("#STRIPDESCRIPTION", strip_tags($produitdesc->description), $temp);	
			$temp = str_replace("#URL", "produit.php?ref=" . "$row->ref" . "&amp;id_rubrique=" . "$row->rubrique", $temp);	
			$temp = str_replace("#REWRITEURL", rewrite_prod("$row->ref"), $temp);	
			$temp = str_replace("#GARANTIE", "$row->garantie", $temp);			
			$temp = str_replace("#PANIERAPPEND", "panier.php?action=" . "ajouter" . "&amp;" . "ref=" . "$row->ref" . "&amp;" . "append=1", $temp);	
			$temp = str_replace("#PANIER", "panier.php?action=" . "ajouter" . "&amp;" . "ref=" . "$row->ref" , $temp);	
			$temp = str_replace("#RUBTITRE", "$rubriquedesc->titre", $temp);
			$temp = str_replace("#CONTPROD", "$countRes", $temp);
			
			$res .= $temp;
			}
		return $res;
		}
	
		
		function action(){
		}
		
		
	}

?>
